/*
 * by Steven Reynolds
 */

package sgexamples;

import com.sun.scenario.effect.Effect;
import com.sun.scenario.effect.Reflection;
import com.sun.scenario.scenegraph.*;
import java.awt.*;
import java.awt.geom.Ellipse2D;
import javax.swing.*;

/**
 *
 * @author int
 */
public class SimpleEffect {

     static final float layoutUnit = 200f;
     static final float ZOOM = 1.0f;

     private SGNode createScene() {
        float x = 0.5f * layoutUnit;
        float y = 0.5f * layoutUnit;
        float size = layoutUnit;
        SGShape circle = new SGShape();
        circle.setShape(new Ellipse2D.Float(x, y, size, size));
        circle.setAntialiasingHint(RenderingHints.VALUE_ANTIALIAS_ON);
        circle.setFillPaint(Color.BLUE);
        SGEffect effect = new SGEffect();
        Effect myEffect = new Reflection();
        effect.setEffect(myEffect);
        effect.setChild(circle);
        SGGroup scene = new SGGroup();
        scene.add(effect);
        SGTransform.Scale zoomNode;
        zoomNode = SGTransform.createScale(1.0, 1.0, null);
        zoomNode.setChild(scene);
        return zoomNode;
     }

     private JComponent createMainPanel() {
        final JSGPanel panel = new JSGPanel() {
            public Dimension getPreferredSize() {
                int panelSize = (int) (2f * layoutUnit * ZOOM);
                return new Dimension(panelSize, panelSize);
            }
        };
        panel.setScene(createScene());
        return panel;
     }

     private static void createAndShowGUI() {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch (Exception e) {
            System.err.println("couldn't set L&F: " + e);
        }
        SimpleEffect app = new SimpleEffect();
        JFrame f = new JFrame("Simplest SG Example");
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.add(app.createMainPanel(), BorderLayout.CENTER);
        f.pack();
        f.setLocationRelativeTo(null);  // center the frame
        f.setVisible(true);
    }

    public static void main(String[] args) {
         SwingUtilities.invokeLater(new Runnable() {

            public void run() {
                createAndShowGUI();
            }
        });
    }

}
